Pulp - Issue #4000

Tests in master are failing due to a change in pulp_file
09/12/2018 12:30 AM - daviddavis
Description

A recent change in pulp_file[0] has caused the tests in pulp to fail. The issue is that tests in pulp are coupled to the pulp_file plugin
code[1] and we're not running pulpcore tests against pulp_file. So any changes to pulp_file could unknowingly break the tests in
pulpcore.

The purist in me thinks that we should not have the tests in pulpcore be dependent on the code in pulp_file and that these tests
should be moved to pulp_file. We're running the pulp_file tests against all pulpcore PRs anyway so moving them wouldn't hurt.

The simplest option however would be to fix these tests and then run the pulpcore tests against pulp_file PRs. That feels kind of
wrong but it's quick and easy.

The third and final option | can think of (and I'm not totally sure how this would work) is to create a bare/mock plugin inside the test
framework and have the pulpcore smash tests use it for tests that require a plugin and content units.

[0] https://github.com/pulp/pulp_file/pull/115
[1] https://github.com/pulp/pulp/tree/master/pulpcore/tests/functional/api/using_plugin

Related issues:
Related to File Support - Story #3912: As a user, | can specify the file mani... CLOSED - CURRENTRELEASE
Related to File Support - Story #3913: As a user | can specify the manifest f... CLOSED - CURRENTRELEASE

Associated revisions

Revision 23f9b5f5 - 09/12/2018 09:14 PM - daviddavis

Fixing tests after change in pulp_file and sphinx options

re #4000 https://pulp.plan.io/issues/4000

fixes #4005 https://pulp.plan.io/issues/4005

Revision 23f9b5f5 - 09/12/2018 09:14 PM - daviddavis

Fixing tests after change in pulp_file and sphinx options

re #4000 https://pulp.plan.io/issues/4000

fixes #4005 https://pulp.plan.io/issues/4005
Revision f3fad23f - 09/12/2018 11:08 PM - daviddavis

Run pulpcore functional tests as part of the Travis job
Since pulpcore functional tests use pulp_file, a change in pulp_file could break these tests.

closes #4000 https://pulp.plan.io/issues/4000

History

#1 - 09/12/2018 12:31 AM - daviddavis

This is causing all PRs against the Pulp master branch to fail so I'm setting the severity to high.

#2 - 09/12/2018 12:33 AM - daviddavis

- Description updated

#3 - 09/12/2018 12:37 AM - daviddavis

- Description updated

#4 - 09/12/2018 12:38 AM - daviddavis

- Subject changed from Tests in master are failing to Tests in master are failing due to a change in pulp_file

#5 - 09/12/2018 03:44 PM - dalley

Long-term, I'm neutral on a mock plugin. Short-term, we should keep the tests in pulpcore, and we should run the "using_plugin" tests in pulpcore
along w/ pulp_file.

#6 - 09/12/2018 03:54 PM - daviddavis

- Related to Story #3912: As a user, | can specify the file manifest name on the remote when syncing and publishing a repository added

#7 - 09/12/2018 03:55 PM - daviddavis

- Related to Story #3913: As a user | can specify the manifest filename when publishing a repo version added

#8 - 09/12/2018 04:01 PM - daviddavis
- Status changed from NEW to POST

- Assignee set to daviddavis

https://qgithub.com/pulp/pulp/pull/3627
https://github.com/pulp/pulp_file/pull/118

#9 - 09/12/2018 04:21 PM - jortel@redhat.com

Short term, | agree with fixing the tests.

Long term, | think having core tests rely on the file plugin is undesirable as demonstrated by this incident. | don't think having a test (mock) plugin in
core code tree is a good idea. However, including a TestPlugin in the pulpcore/tests/functional code tree seems reasonable.

#10 - 09/12/2018 04:42 PM - daviddavis
Cool, thanks for the feedback dalley and @jortel. | will use this bug to fix the tests.

I've opened a separate issue to continue discussions around using a test plugin: https://pulp.plan.io/issues/4003.
#11 - 09/12/2018 04:51 PM - kersom

Based on the previous comments, | think that if certain core feature requires a plugin in order to be tested this test should live inside the plugin
repository, and not be part of the core repository.

Besides that, if possible we should use one plugin to test all the core features that require a plugin. Or at least, most of the features.

#12 - 09/12/2018 11:08 PM - daviddavis
- Status changed from POST to MODIFIED

Applied in changeset pulp_file:f3fad23f1a024682391f2a92b182282da6448977.

#13 - 04/25/2019 06:44 PM - daviddavis
- Sprint/Milestone set to 3.0.0

#14 - 04/26/2019 10:34 PM - bmbouter
- Tags deleted (Pulp 3)

#15 - 12/13/2019 06:33 PM - bmbouter
- Status changed from MODIFIED to CLOSED - CURRENTRELEASE
